<?php

namespace Drupal\eav_field;

use Drupal\Core\TypedData\TypedData;
use Drupal\eav_field\Plugin\Field\FieldType\EavItem;

class EavItemComputedValue extends TypedData {

  /**
   * Cached EAV attribute value.
   */
  protected $value;

  /**
   * {@inheritdoc}
   */
  public function getValue() {
    if ($this->value === NULL) {
      $eav_item = $this->getParent(); /** @var EavItem $eav_item */
      $eav_attribute_type = $eav_item->getValueType();

      $this->value = $eav_item->{$eav_attribute_type . '_value'};
    }

    return $this->value;
  }

}
