<?php

namespace Drupal\eav_field\Plugin\Derivative;

use Drupal\Component\Plugin\Derivative\DeriverBase;
use Drupal\Core\Entity\EntityFieldManagerInterface;

class EavFieldLocalTaskDeriver extends DeriverBase {

  /**
   * {@inheritDoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $entity_field_manger = \Drupal::service('entity_field.manager'); /** @var EntityFieldManagerInterface $entity_field_manger */
    $eav_fields = $entity_field_manger->getFieldMapByFieldType('eav');

    foreach (array_keys($eav_fields) as $entity_type_id) {
      $eav_field_name = array_key_first($eav_fields[$entity_type_id]);
      $entity_bundle_name = current($eav_fields[$entity_type_id][$eav_field_name]['bundles']);
      $eav_field_label = \Drupal::service('entity_field.manager')->getFieldDefinitions($entity_type_id, $entity_bundle_name)[$eav_field_name]->getLabel();

      $this->derivatives[$entity_type_id] = [
        'title' => t('Edit @label', ['@label' => $eav_field_label]),
        'route_name' => "entity.$entity_type_id.edit_eav_attributes",
        'base_route' => "entity.$entity_type_id.canonical",
        'weight' => 20,
      ] + $base_plugin_definition;
    }

    return parent::getDerivativeDefinitions($base_plugin_definition);
  }

}
